#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = cipalite
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: apas.pleaf.m4,v 1.19 2022/09/04 15:04:21 babolo Exp $
#
#   

eval
#select  t00_
SELECT CIAT(b) FROM CINM(x);
#begin   0002 --    ####################################################################
#select  _0t2
WITH s AS(SELECT SQNM(sess).SQAT(sess)
               , (CAST(?1 AS real) - COALESCE( SQNM(sess).SQAT(ttl)
                                             , SQNM(pass).SQAT(ttl)
                                             , SQNM(cipaconf).SQAT(ttl)
                 )                           ) AS s
           FROM  SQNM(cipaconf)
              ,  SQNM(x)
            JOIN SQNM(sess) USING(SQAT(cred), SQAT(srcip))
            JOIN SQNM(pass) USING(SQAT(cred))
           WHERE   SQNM(x).SQAT(sess)
                == ( (SQNM(sess).SQAT(sess) * SQNM(cipaconf).SQAT(a3))
                   + SQNM(cipaconf).SQAT(a2)
                   ) % SQNM(cipaconf).SQAT(a1)
             AND SQNM(pass).SQAT(context) = SQNM(x).CIAT(cipa)
             AND (  CINM(x).CIAT(cred) > 0
                 OR NOT CINM(x).CIAT(u)
                 OR (   CINM(x).CIAT(login) == SQNM(sess).CIAT(login)
                    AND (  CINM(x).CIAT(pass) == SQNM(sess).CIAT(pass)
                        OR (CINM(x).CIAT(pass) IS NULL AND SQNM(sess).CIAT(pass) IS NULL)
                 )  )   )
             AND SQNM(sess).SQAT(updated) >= (CAST(?1 AS real) - COALESCE( SQNM(sess).SQAT(ttl)
                                                                         , SQNM(pass).SQAT(ttl)
                                                                         , SQNM(cipaconf).SQAT(ttl)
                                             )                           )
          LIMIT 1
         )
UPDATE SQNM(x)
   SET SQAT(sess) = (SELECT SQAT(sess) FROM s)
RETURNING ?1, (SELECT s FROM s), SQAT(sess)
;
#perform 00_2
UPDATE SQNM(sess)
   SET SQAT(updated) = ?1
     , SQAT(cnt) = SQAT(cnt) + 1
 WHERE SQAT(sess) = CAST(?3 AS INTEGER)
;
#select  _0t2
INSERT INTO SQNM(sess)( SQAT(cred)
                      , SQAT(login)
                      , SQAT(pass)
                      , SQAT(srcip)
                      , SQAT(flags)
                      , SQAT(created)
                      , SQAT(updated)
                      )
 SELECT SQNM(x).SQAT(cred)
      , SQNM(x).SQAT(login)
      , SQNM(x).SQAT(pass)
      , SQNM(x).SQAT(srcip)
      , SQNM(pass).SQAT(flags) & PassToSess
      , SQNM(x).SQAT(b)
      , SQNM(x).SQAT(b)
  FROM SQNM(x) JOIN SQNM(pass) USING(SQAT(cred))
  WHERE SQNM(x).SQAT(sess) IS NULL
RETURNING ?1, SQAT(sess)
;
#perform 00_2
UPDATE SQNM(sess)
   SET SQAT(updated) = ?1
     , SQAT(cnt) = SQAT(cnt) + 1
 WHERE SQAT(sess) = CAST(?2 AS INTEGER)
;
#select  1002
SELECT ( (SQNM(sess).SQAT(sess) * SQNM(cipaconf).SQAT(a3))
       + SQNM(cipaconf).SQAT(a2)
       ) % SQNM(cipaconf).SQAT(a1)
 FROM SQNM(cipaconf), SQNM(sess) JOIN SQNM(sessb) USING(SQAT(sess))
;
#eval    001
##echo    00000_
serr
##echo    01
##exit
#perform 00_2
UPDATE SQNM(x) SET SQAT(sess) = ?2;
#select  _0t2 --   
WITH d AS(SELECT SQNM(sess).SQAT(sess)
           FROM  SQNM(cipaconf)
              ,  SQNM(x)
              ,  SQNM(sess) JOIN SQNM(pass) USING(SQAT(cred))
           WHERE SQNM(pass).SQAT(context) = SQNM(x).CIAT(cipa)
             AND SQNM(sess).SQAT(updated) < (CAST(?1 AS real) - COALESCE( SQNM(pass).SQAT(ttl)
                                                                        , SQNM(sess).SQAT(ttl)
                                                                        , SQNM(cipaconf).SQAT(ttl)
         )                                  )                           )
DELETE FROM SQNM(sess)
 WHERE SQAT(sess) IN(SELECT d.SQAT(sess) FROM d)
RETURNING *, ?1
;
#perform 00_2
INSERT INTO SQNM(sessb) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);
#end     0002  ########################################################################################
#select  1002
SELECT ((SQNM(x).SQAT(sess) * SQNM(cipaconf).SQAT(a3)) + SQNM(cipaconf).SQAT(a2))
     % SQNM(cipaconf).SQAT(a1)
 FROM SQNM(x), SQNM(cipaconf)
;
#perform 001_
UPDATE CINM(x) SET CIAT(tosess) = ?;
#select  201_
SELECT CASE WHEN CINM(g).CINM(i) > 0 THEN '&' ELSE '?' END                       AS delim
     , CASE WHEN CINM(g).CINM(i) > 0 THEN CINM(g).CIAT(n) ELSE ? END              AS left
     , CASE WHEN CINM(g).CINM(i) > 0 THEN CINM(g).CIAT(g) ELSE CINM(x).CIAT(p) END AS right
 FROM CINM(g), CINM(x)
;
#select  _00_
SELECT 1
 FROM CINM(x)
 WHERE COALESCE(CINM(x).CIAT(sess) <> CINM(x).CIAT(tosess), 1)
;
#eval    00_
##echo    00000_
moved302
##display 00200_
##exit
#close   20200_
#close   101
#close   _0_
